<script>
import { Line } from "vue-chartjs";

export default {
  extends: Line,
  mounted() {
    console.log("chart rendered");
    this.renderChart(this.getData(), this.getOptions("Dive"));
    this.updateChart();
  },
  computed: {
    currentDive() {
      return this.$store.state.currentDive;
    },
  },
  watch: {
    currentDive() {
      this.updateChart();
    },
  },
  methods: {
    updateChart() {
      console.log("updating chart");
      const time = [];
      const depth = [];
      this.currentDive.samples.forEach(function (sample) {
        time.push(sample.time);
        depth.push(sample.depth);
      });
      this.renderChart(
        this.getData(time, depth, this.currentDive.date),
        this.getOptions("Divecurve from " + this.currentDive.date)
      );
    },
    getData(labels, data, label) {
      return {
        labels: labels,
        datasets: [
          {
            label: label == null ? "Select a dive" : "Dive from " + label,
            data: data,
            backgroundColor: "transparent",
            borderColor: "rgba(1, 116, 188, 0.50)",
            pointBackgroundColor: "rgba(171, 71, 188, 1)",
            pointRadius: 1,
          },
        ],
      };
    },
    getOptions(text) {
      return {
        responsive: true,
        maintainAspectRatio: false,
        title: {
          display: true,
          text: text,
        },
        scales: {
          yAxes: [
            {
              ticks: {
                reverse: true,
              },
            },
          ],
        },
      };
    },
  },
};
</script>

<style>
div#tauchgang {
  height: 40%;
}
</style>
